#!/usr/bin/ruby

# dp_stm_map - Distributed and Persistent Software Transaction Map
# Copyright (C) 2013  Dragan Milic
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

require 'dp_stm_map'
require 'optparse'


port=0
store_dir=nil
OptionParser.new do |opts|
  opts.banner == "Usage: dp_map_manager.rb -p <port>"
  opts.on("-p N", Integer, "TCP port number where server should accept conntections") do |p|
    port=p
  end

  opts.on("-s DIR", "Directory for storage") do |dir|
    store_dir=dir
  end

end.parse!

server=DpStmMap::Manager.new port, store_dir

server.start
puts "Manager started at port #{server.port}"
STDOUT.flush

$stdin.each do |line|
  if /^quit/.match line
    server.stop
    puts "Manager shut down"
    STDOUT.flush
    exit(0)
  end
end
